#################################################################################
# users_today_2.pl (Users Today - Sources)                                      #
#################################################################################
# Written for YaBB 2.x                                                          #
# Author: Brian Longo (aka, Mongo)                                              #
# email: webamster@eyeontoccoa.com                                              #
# http://www.eyeontoccoa.com/mods/                                              #
# Version: 1.8                                                                  #
# Date: January 17, 2006                                                        #
# Version History:                                                              #
# 1.0 - Original Release                                                        #
# 1.1 - New .pl file added to Sources directory.                                #
# 1.2 - New stat features added as well as minor bugs fixed.                    # 
# 1.3 - This file's version upped to match admin file and mod file.             #
# 1.4 - Added spot to respect $log_only variable where Users Today box in Board #
#       Index will not be shown.                                                #
# 1.5 - New "double check" system implemented where sometimes user names weren't#
#       being added with only the $username variable - now uses the log's $name #
#       variable to add those "stubborn" names to the userstoday.txt file.      #
# 1.6 - Fixed bug where log would get messed up from using both $dd and $mday   #
#       from DateTime.pl.  Now a uniform date variable is used from the server. #
# 1.7 - Added option for users to view log from YaBB.pl.  Admin has control of  #
#       which groups (Admins, GMods, users, guests) are able to view the "public#
#       log" via the Admin Center.                                              #
# 1.8 - Fixed a few spots where hardcoded text was present.                     #
#################################################################################

if ($action eq 'detailedversion') { return 1; }

use Time::Local 'timelocal';

LoadLanguage("users_today");

sub users_today {
## need to have a uniform date for the guests and users files: ##
    ($blank, $blank, $blank, $utday, $utmon, $utyear, $utwday, $blank, $blank) = gmtime(time + (3600 * $timeoffset));

    $utmon_num  = $utmon +1;
	$utsaveyear = ($utyear % 100);
	$utyear     = 1900 + $utyear;
	$utmon_num  = "0$utmon_num"  if ($utmon_num < 10);
	$utday      = "0$utday"      if ($utday < 10);
	$utsaveyear = "0$utsaveyear" if ($utsaveyear < 10);

## create files to avoid the intial "dreaded -1" on first load ##
	if(!-e("$vardir/usertoday.txt")){
	   fopen(FILE,">$vardir/usertoday.txt");
	   print FILE "$utmon_num|$utday|$utsaveyear|$utwday\n";
	   print FILE "$utday\n";
	   fclose(FILE);
	}
	if(!-e("$vardir/guesttoday.txt")){
	   fopen(GUESTFILE,">$vardir/guesttoday.txt");
	   print GUESTFILE "$utday\n";
	   fclose(GUESTFILE);
	}
	if(!-e("$vardir/uttotal.txt")){
	   fopen(UTTOTAL,">$vardir/uttotal.txt");
	   fclose(UTTOTAL);
	}
	if(!-e("$vardir/utstats.txt")){
	   fopen(UTSTATS, ">$vardir/utstats.txt");
	   fclose(UTSTATS);
	}
	fopen(FILE,"$vardir/usertoday.txt");
	@utoday=<FILE>;
	fclose(FILE);
	$usertodaycount = @utoday;
	$usertoday = '';
	for($a=2;$a < $usertodaycount;$a++){
	   $utoday[$a] =~ s/\n//gi;
	   $utname = $utoday[$a];
   	   if($utname ne ''){&LoadUser($utname);}
   	   if(!$link{$utname}){&LoadMiniUser($utname);}
	   if($utname eq $username){$Inserted1 = 'true';}
	   if(-e ("$memberdir/$name.vars") && $utname eq $name){$Inserted2 = 'true';}
	   $usertoday .= qq~$link{$utname}~;
	   $usertoday .= qq~, ~;
	}
	$usertodaycount = $usertodaycount-2;
	if(!$iamguest && ($Inserted1 && $Inserted2) ne 'true'){
	   if($Inserted1 ne 'true'){
	      fopen(FILE,">>$vardir/usertoday.txt");
	      print FILE "$username\n";
	      fclose(FILE);
	   }
	   elsif(-e ("$memberdir/$name.vars") && $Inserted2 ne 'true'){
	      fopen(FILE,">>$vardir/usertoday.txt");
	      print FILE "$name\n";
	      fclose(FILE);
	   }
	}
	elsif(!$iamguest && $Inserted1 eq 'true' && $Inserted2 ne 'true'){
       fopen(FILE,">>$vardir/usertoday.txt");
	   print FILE "$username\n";
	   fclose(FILE);
	}
	elsif(!$iamguest && $Inserted1 ne 'true' && $Inserted2 eq 'true'){
       fopen(FILE,">>$vardir/usertoday.txt");
	   print FILE "$name\n";
	   fclose(FILE);
	}
    $usertoday =~ s~, \Z~~;
	if($usertodaycount eq 1){$userstoday = qq~$uttxt{'1'}<b>$usertodaycount</b>$uttxt{'3'}<br />$usertoday~;}
	else{$userstoday = qq~$uttxt{'1a'}<b>$usertodaycount</b>$uttxt{'3a'}<br />$usertoday~;}
## Reading the guests today file ##
    open(GUESTFILE,"$vardir/guesttoday.txt");
	@gtoday=<GUESTFILE>;
	close(GUESTFILE);
	$guesttodaycount = @gtoday;
	for($g=1;$g < $guesttodaycount;$g++){
	   $gtoday[$g] =~ s/\n//gi;
	   $g_ip = $gtoday[$g];
       if($g_ip eq $user_ip){$gInserted = 'true';}
	   if($view_ips eq 1 && ($iamadmin || $iamgmod)){
	      $guesttoday .= qq~$g_ip~;
		  if($guesttodaycount > 1) {$guesttoday .= qq~, ~;}
	   }
	   else {$guesttoday = qq~<!--Not listing IP addresses-->~;}
	}
	$guesttodaycount = $guesttodaycount-1;
	if($view_ips eq 1 && ($iamadmin || $iamgmod)){
	   if($guesttodaycount eq 1){$guesttrailtext = qq~$uttxt{'2b'}<br />~;}
	   else{$guesttrailtext = qq~$uttxt{'2c'}<br />~;}
	}
	else{
	   if($guesttodaycount eq 1){$guesttrailtext = qq~$uttxt{'2'}~;}
	   else {$guesttrailtext = qq~$uttxt{'2a'}~;}
	}			
	if($gInserted ne 'true' && $username eq 'Guest'){
	   fopen(GUESTFILE,">>$vardir/guesttoday.txt");
	   print GUESTFILE "$user_ip\n";
	   fclose(GUESTFILE);
	}
## Prepare data from usertoday.txt and guesttoday.txt for writing to log file ##
    if(($utoday[1] || $gtoday[0]) != $utday){
       fopen(YFILE,"$vardir/usertoday.txt");
	   @usersyest=<YFILE>;
	   fclose(YFILE);
	   $usercount=@usersyest;
	   $usercount=$usercount-2;
   	   fopen(YGUESTFILE,"$vardir/guesttoday.txt");
	   @guestyest=<YGUESTFILE>;
	   fclose(YGUESTFILE);
	   $guestcount=@guestyest;
	   $guestcount=$guestcount-1;  
	   ($yestmon, $yestday, $yestyear, $yestdoy) = split(/\|/, $usersyest[0]);
	   chomp $yestdoy;	   
## Add yesterday's user and guest count to log file ##
   	   my ($memcount, $latestmember) = &MembershipGet;
	   $mempercent = ($usertodaycount / $memcount) * 100;
	   my $mempercent = sprintf ("%.2f", $mempercent);
	   fopen(UTTOTAL,">>$vardir/uttotal.txt");
       print UTTOTAL "$yestmon|$yestday|$yestyear|$yestdoy|$usercount|$mempercent|$guestcount\n";
       fclose(UTTOTAL);
## Check stats file to see if it needs updating ##
	   fopen(UTSTATS, "$vardir/utstats.txt");
	   @utstats = <UTSTATS>;
	   fclose(UTSTATS);
	   ($utmostuser, $utmumo, $utmuday, $utmuyr) = split(/\|/, $utstats[0]);
	   ($utmostguest, $utmgmo, $utmgday, $utmgyr) = split(/\|/, $utstats[1]);
	   ($uttotaluser) = $utstats[2];
	   ($uttotalguest) = $utstats[3];
	   ($utlogdays) = $utstats[4];
	   chomp $utmuyr;
	   chomp $utmgyr;
	   chomp $uttotaluser;
	   chomp $uttotalguest;
	   chomp $utlogdays;
	   fopen(UTSTATS, ">$vardir/utstats.txt");
	   if($usercount >= $utmostuser){$utmostuser = $usercount; $utmumo = $yestmon; $utmuday = $yestday; $utmuyr = $yestyear;}
	   if($guestcount >= $utmostguest){$utmostguest = $guestcount; $utmgmo = $yestmon; $utmgday = $yestday; $utmgyr = $yestyear;}
	   $uttotaluser = $uttotaluser + $usercount;
	   $uttotalguest = $uttotalguest + $guestcount;
	   $utlogdays = $utlogdays + 1;
	   $utavguser = ($uttotaluser/$utlogdays);
	   my $utavguser = sprintf ("%.2f", $utavguser);
	   $utavgguest = ($uttotalguest/$utlogdays);
	   my $utavgguest = sprintf ("%.2f", $utavgguest);
	   print UTSTATS "$utmostuser|$utmumo|$utmuday|$utmuyr\n";
	   print UTSTATS "$utmostguest|$utmgmo|$utmgday|$utmgyr\n";
	   print UTSTATS "$uttotaluser\n";
	   print UTSTATS "$uttotalguest\n";
	   print UTSTATS "$utlogdays\n";
	   print UTSTATS "$utavguser\n";
	   print UTSTATS "$utavgguest\n";
	   print UTSTATS "$memcount\n";
	   fclose(UTSTATS);
## Clear usertoday.txt for new day ##
	   fopen(FILE,">$vardir/usertoday.txt");
	   print FILE "$utmon_num|$utday|$utsaveyear|$utwday\n";
	   print FILE "$utday\n";
## Clear guesttoday.txt for new day ##
   	   fopen(GUESTFILE,">$vardir/guesttoday.txt");
	   print GUESTFILE "$utday\n";
	   fclose(GUESTFILE);
	}
	if($show_guest_today eq 1) {
	   $onlinetoday = qq~$uttxt{'4'}$uttxt{'4a'}~;
	   if(($iamadmin || $iamgmod) && $guest_ip eq 1 && $link_guest eq 1){
	      if($guesttodaycount eq 1){$gueststoday = qq~$uttxt{'1'}<a href="$boardurl/AdminIndex.$yyaext?action=users_today" style="color: red; text-decoration: underline;"><b>$guesttodaycount</b></a>$guesttrailtext$guesttoday<br />~;}
	      else{$gueststoday = qq~$uttxt{'1a'}<a href="$boardurl/AdminIndex.$yyaext?action=users_today" style="color: red; text-decoration: underline;"><b>$guesttodaycount</b></a>$guesttrailtext$guesttoday<br />~;}
	   }
	   else{
	      if($guesttodaycount eq 1){$gueststoday = qq~$uttxt{'1'}<b>$guesttodaycount</b>$guesttrailtext$guesttoday<br />~;}
	      else{$gueststoday = qq~$uttxt{'1a'}<b>$guesttodaycount</b>$guesttrailtext<br />$guesttoday~;}
	   }
	}
	else{
	   $onlinetoday = qq~$uttxt{'4a'}~; 
	   $gueststoday = qq~<!--Not Available -->~;
	}
	if($log_only eq 1){
	   $row_resize = qq~
	   <td class="windowbg" width="5%" valign="middle" align="center">
		  <img src="$imagesdir/online.gif" border="0" alt="" />
	   </td>~;
	   $users_today = qq~<!--Not Available-->~;
	}
	elsif(($iamguest && $guest_view eq 1) || $username ne 'Guest'){
	   if($plogopt eq 1){
	      if($plogopt2 eq 0 && $iamadmin){$showplog = qq~<br><a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;}
	      elsif($plogopt2 eq 1 && ($iamadmin || $iamgmod)){$showplog = qq~<br><a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;}
		  elsif($plogopt2 eq 2 && !$iamguest){$showplog = qq~<br><a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;}
		  elsif($plogopt2 eq 3){$showplog = qq~<br><a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;}
	      else{$showplog = qq~<!--Not for you to see-->~;}
	   }
	   else{$showplog = qq~<!--Not for you to see-->~;}
	$row_resize = qq~
		<td class="windowbg" width="5%" valign="middle" align="center" rowspan="3">
		   <img src="$imagesdir/online.gif" border="0" alt="" />
		</td>~;
    $users_today = qq~
	  <tr>
        <td class="catbg" valign="top" align="center">$onlinetoday</td>
      </tr>
	  <tr>
        <td class="windowbg2" valign="top" align="center">
        <div class="small" style="float: left; width: 100%; text-align: left;">$gueststoday$userstoday</div>
		<br /><span style="text-align: center;">$showplog</span>
      </td>
    </tr>~;
	}
	else {
	   $row_resize = qq~
	   <td class="windowbg" width="5%" valign="middle" align="center">
		  <img src="$imagesdir/online.gif" border="0" alt="" />
	   </td>~;
	   $users_today = qq~<!--Not Available-->~;
	}
    $boardindex_template =~ s/<yabb row_resize>/$row_resize/g;
	$boardindex_template =~ s/<yabb users_today>/$users_today/g;
}

sub show_utlog {
   if($plogopt eq 1){
      if($plogopt2 eq 0 && $iamadmin){$showplog = qq~<br /><a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;}
	  elsif($plogopt2 eq 1 && ($iamadmin || $iamgmod)){$showplog = qq~<br /><a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;}
	  elsif($plogopt2 eq 2 && !$iamguest){$showplog = qq~<br /><a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;}
	  elsif($plogopt2 eq 3){$showplog = qq~<br /><a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;}
	  else{&fatal_error($security_txt{'1'});}
   }
   else{&fatal_error($security_txt{'1'});}
   LoadLanguage("users_today");
   $yytitle = "$uttxt{'16'}";
   $yymain .= qq~
   <table class="bordercolor" width="100%" cellspacing="1" style="margin-left: auto; margin-right: auto;">
      <tr valign="middle">
         <td align="center" class="titlebg" colspan="6"><b>$uttxt{'16'}</b></td>
	  </tr>
      <tr valign="middle">
	     <td width="25%" align="left" class="windowbg2"><b>$uttxt{'13'}</b></td>
	     <td width="15%" align="center" class="windowbg2"><b>$uttxt{'14'}&nbsp;$uttxt{'14a'}</b></td>
	     <td width="10%" align="center" class="windowbg2"><b>$uttxt{'15'}</b></td>
      	 <td width="25%" align="left" class="windowbg2"><b>$uttxt{'13'}</b></td>
	     <td width="15%" align="center" class="windowbg2"><b>$uttxt{'14'}&nbsp;$uttxt{'14a'}</b></td>
	     <td width="10%" align="center" class="windowbg2"><b>$uttxt{'15'}</b></td>
	  </tr>~;
     if (-e ("$vardir/uttotal.txt")) {
       fopen(TOTUSER,"$vardir/uttotal.txt");
	   @totusers=<TOTUSER>;
	   fclose(TOTUSER);
	   $countlog = @totusers;
	   $column_stop = 0;
	   $break_line = ($countlog / 2);
	   $check_odd = int($countlog / 2);
	   if($break_line eq $check_odd){$column_stop = $break_line;}
	   else{$column_stop = $check_odd+1;}
	   for($t=$0;$t < $column_stop;$t++){
	      chomp $userstat;
	      ($utmonth, $utday, $utyear, $utdow, $totuser, $mempercent, $totguest) = split(/\|/, $totusers[$t]);
		  ($utmonth2, $utday2, $utyear2, $utdow2, $totuser2, $mempercent2, $totguest2) = split(/\|/, $totusers[$t+$column_stop]);
		  for($checkut=1;$checkut < 10;$checkut++){
	         $checkut2 = "0$checkut";
	         if($utday eq $checkut2){$utday = $checkut;}
	         if($utday2 eq $checkut2){$utday2 = $checkut;}
	      }
		  &datestyle;
		  $logdate = $dateformat_log2;
		  if($utmonth2 ne ''){$logdate2 = qq~$days[$utdow2], $dateformat_log3~;}
		  else{$logdate2 = qq~<!--Blank-->~;}
		  $mempercent = qq~<span style="color: red; font-style: italic;">($mempercent)</span>~;
		  if($mempercent2 ne ''){$mempercent2 = qq~<span style="color: red; font-style: italic;">($mempercent2)</span>~;}
		  else{$mempercent2 = qq~<!--Blank-->~;}
		  $yymain .= qq~
		  <tr valign="middle">
		     <td width="25%" align="left" class="windowbg2"><span style="font-size: 10px;">$days[$utdow], $logdate</span></td>
		     <td width="15%" align="center" class="windowbg2"><span style="font-size: 10px;">$totuser&nbsp;$mempercent</span></td>
		     <td width="10%" align="center" class="windowbg2"><span style="font-size: 10px;">$totguest</span></td>
		     <td width="25%" align="left" class="windowbg2"><span style="font-size: 10px;">$logdate2</span></td>
		     <td width="15%" align="center" class="windowbg2"><span style="font-size: 10px;">$totuser2&nbsp;$mempercent2</span></td>
		     <td width="10%" align="center" class="windowbg2"><span style="font-size: 10px;">$totguest2</span></td>		  
		  </tr>~;
	   }
	   }
	 $yymain .= qq~
	 </table>~;  
	 &template;
	 exit; 
}

## define $dateformat ##
sub datestyle {
   if($date_style eq 0){
      $dateformat_guest = qq~, $mon_num/$mday/$year~;
	  $dateformat_log = qq~$utmonth/$utday/20$utyear~;
	  $dateformat_log2 = qq~$utmonths[$utmonth-1] $utday, 20$utyear~;
	  $dateformat_log3 = qq~$utmonths[$utmonth2-1] $utday2, 20$utyear2~;
	  $dateformat_user_stats = qq~$utmumo/$utmuday/20$utmuyr~;
	  $dateformat_guest_stats = qq~$utmgmo/$utmgday/20$utmgyr~;
   }
   elsif($date_style eq 1){
      $iplogyear = $year-2000;
	  $iplogyear = "0$iplogyear" if ($iplogyear < 10); 
	  $dateformat_guest = qq~, $mon_num/$mday/$iplogyear~;
	  $dateformat_log = qq~$utmonth/$utday/$utyear~;
	  $dateformat_log2 = qq~$utmonths[$utmonth-1] $utday, 20$utyear~;
	  $dateformat_log3 = qq~$utmonths[$utmonth2-1] $utday2, 20$utyear2~;
	  $dateformat_user_stats = qq~$utmumo/$utmuday/$utmuyr~;
	  $dateformat_guest_stats = qq~$utmgmo/$utmgday/$utmgyr~;
   }
   elsif($date_style eq 2){
      $dateformat_guest = qq~, $mday.$mon_num.$year~;
	  $dateformat_log = qq~$utday.$utmonth.20$utyear~;
	  $dateformat_log2 = qq~$utday $utmonths[$utmonth-1], 20$utyear~;
	  $dateformat_log3 = qq~$utday2 $utmonths[$utmonth2-1], 20$utyear2~;
	  $dateformat_user_stats = qq~$utmuday.$utmumo.20$utmuyr~;
	  $dateformat_guest_stats = qq~$utmgday.$utmgmo.20$utmgyr~;
   }
   elsif($date_style eq 3){
      $iplogyear = $year-2000;
	  $iplogyear = "0$iplogyear" if ($iplogyear < 10);
      $dateformat_guest = qq~, $mday.$mon_num.$iplogyear~;
      $dateformat_log = qq~$utday.$utmonth.$utyear~;
	  $dateformat_log2 = qq~$utday $utmonths[$utmonth-1], 20$utyear~;
	  $dateformat_log3 = qq~$utday2 $utmonths[$utmonth2-1], 20$utyear2~;
	  $dateformat_user_stats = qq~$utmuday.$utmumo.$utmuyr~;
	  $dateformat_guest_stats = qq~$utmgday.$utmgmo.$utmgyr~;
   }
}

1;