<id>
Users Today for YaBB 2.x
</id>

<version>
1.8
</version>

<mod info>
**Original code and concept by Daicogra for YaBB 1.1.  Re-coding to work with YaBB 2.x as well as "Enhancements" to this mod have been made by Brian Longo.  I DO NOT take credit for the original concept of this mod.  However, I will take credit for the enhancements to this mod.

**Overview:

Daicoga's original version:
-- Count the number of members that visit your board on any given day.  At midnight, the counter is reset to zero.

My "enhancements":
-- Added the capability to count guests.  Counter for guests resets to zero at midnight.
-- Option to show or not show the number of guests along with the number of members in the Users Online Today box in Board Index.
-- Option to allow or disallow guests from seeing the Users Online Today box in Board Index.
-- Admin has the option of viewing the Guest IP Log in the Users Today section of the Admin Center below configuration box.
-- Admin has the option of enabling number of guests in Board Index as a link to go directly to the Users Today section of the Admin Center to view the Guest IP Log.
-- Admin can see user/guest stats for forum by day (log file).
-- Admin can view when most users/guests came to their board, as well as total number of users/guests and average users/guests per day.
-- Admin can choose to see log file for X days via an input value.
-- Admin can choose to use this as a "Log Only" mod where the Users Today block will not show up in the Board Index, yet still keep user/guest stats for the board.

**Installation Instructions:

1) As always, back up your current board first!
2) Uninstall any previous version of this mod.
3) Run this mod.
4) Upload the modded files and make sure their CHMOD settings are correct.
5) Upload the users_today.pl file to your Admin directory and CHMOD it to 666 (like the rest of the files in that directory).
6) Upload the users_today.lng file to your Languages/English directory and CHMOD it to 777 (like the rest of the .lng files in that directory).
7) Upload the users_today_2.pl file to your Sources directory and CHMOD it to 755 (like the rest of the files in that directory).

**Modifies the following files:

-- AdminIndex.pl
-- YaBB.pl
-- Admin/AdminSubList.pl
-- Admin/ModList.pl
-- Sources/BoardIndex.pl
-- Sources/SubList.pl
-- Templates/default/BoardIndex.template

## Thanks to Jet Li for providing a German translation for this mod ##

**Please report any comments, questions, problems and/or bugs to webmaster@eyeontoccoa.com

Version History:

## 1.0 ##
-- First release (rewrote original code to work with YaBB 2 and added enhancements)

## 1.1 ##
-- Created a seperate users_today_2.pl file as mod was getting to be very large in BoardIndex.pl.
-- Added option to list guests' IP addresses in Users Today list in the board index.
-- Fixed a minor bug where if the show guests' IP addresses in the Users Today box option was selected, the IP addresses didn't display correctly.

## 1.2 ##
-- Minor bugs fixed as well as fixed a "collision" with AK108's Board Index User Cache mod.
-- Enhanced the users_today_2.pl file (Sources) where stats are being tracked for users and guests.
-- Enhanced the users_today.pl file (Admin) to allow admin to choose their date/time format, see the "Max Stats" (Most users/guests on, total number of users/guests to their board, average number of users/guest per day).
-- Also, admin can now view user/guest log file in Users Today Admin screen.

## 1.3 ##
-- Added input value to see the log file X amount of days.  Log will continue to build, but will only show X days from current date.
-- Fixed problem with tables being viewed in different broswers (padding/margin issue).

## 1.4 ##
-- Added a new variable where the Admin can choose to not display the Users Today block in the Board Index and just use the mod to track user/guest stats.

## 1.5 ##
-- New "double check" system implemented where sometimes user names weren't being added with only the $username variable - now uses the log's $name variable to add those "stubborn" names to the userstoday.txt file.   

## 1.6 ##
-- Fixed bug where log would get messed up from using both $dd and $mday from DateTime.pl.  Now a uniform date variable is used from the server.

## 1.7 ##
-- Added capability to view log in Admin Center in three different ways:
   - Full log (all entries)
   - "X" amount of days from the last log entry
   - From "A" date to "B" date 
-- Added option for users to view log from YaBB.pl.  Admin has control of which groups (Admins, GMods, users, guests) are able to view the "public log" via the Admin Center. 

## 1.8 ##
-- Fixed a few spots where hardcoded text was present in the users_today_2.pl file.
-- Fixed a few bugs from last version and also added a "Clean Log" option and a "Recover Log" option. 
</mod info>

<author>
Daicogra (1.1), Brian Longo (2.x)
</author>

<homepage>
http://www.eyeontoccoa.com/mods
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$users_today = "users_today|Users Today Mod|Users Today Mod|";
push (@boardmod_mods, "$users_today");
</add before>

<edit file>
YaBB.pl
</edit file>

<search for>
&banning;     # Check for banned people
&WriteLog;    # Write to the log
&LoadIMs;     # Load IM's
</search for>

<add before>
if (-e("$vardir/usrtodayconfig.txt"))  { ## Users Today Mod ##
    require "$vardir/usrtodayconfig.txt";
}

</add before>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'smilieindex',"Smilies.pl&SmilieIndex",
'smiliemove',"Smilies.pl&SmilieMove",
</search for>

<add after>
'users_today',"users_today.pl&users_today_set", ## Users Today Mod ##
'users_today2',"users_today.pl&users_today_set_2", ## Users Today Mod ##
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$users_today_mod = "Users Today|Brian Longo|Counts the number of members and guests that visit your board each day.  Counters are reset at midnight.  Also will log the number of users and guests to your board and is viewable through the Admin Center.  Original code by daicogra.  Enhancements/log by me.|1.8|1/17/2006";
	push (@installed_mods, "$users_today_mod");
</add before>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	if ($showlatestmember) {
		&LoadUser($latestmember);
		$latestmemberlink = qq~$boardindex_txt{'201'} <a href="$scripturl?action=viewprofile;username=$useraccount{$latestmember}"><b>${$uid.$latestmember}{'realname'}</b></a>.<br />~;
		$boardindex_template =~ s/<yabb latestmember>/$latestmemberlink/g;
	} else {
		$boardindex_template =~ s/<yabb latestmember>//g;
	}
</search for>

<add after>
## Start Users Today Mod ##
    require "$sourcedir/users_today_2.pl";
    &users_today;
## End Users Today Mod ##
</add after>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'setgtalk',"Display.pl&SetGtalk",
</search for>

<add after>
'showlog',"users_today_2.pl&show_utlog",  # Users Today Mod #
</add after>

<edit file>
Templates/default/BoardIndex.template
</edit file>

<search for>
	<td class="windowbg" width="5%" valign="middle" align="center">
		<img src="$imagesdir/online.gif" border="0" alt="" />
	</td>
</search for>

<replace>
    <yabb row_resize><!-- ## Users Today mod ## -->
</replace>

<search for>
		$boardindex_txt{'802'} <b><yabb mostguests></b> $maintxt{'30'} <yabb mostguestsdate>
		</div>
	</td>
</tr>
</search for>

<add after>
<!-- ## Start Users Today mod ## -->
<yabb users_today>
<!-- ## End Users Today mod ## -->
</add after>